/*
	$Id: Typedef.java 170 2006-04-08 21:16:55Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   Ǥ

   typedefǤбޤ
*/
public class Typedef {

    /** name° */
    private String name;

    /** as° */
    private String as;

    /** descǤ */
    private Description desc;

    /**
       ޤ

       @param elem typedef
    */
    public Typedef(final Element elem) {
	name = elem.getAttribute("name");
	as = elem.getAttribute("as");

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       name°ͤޤ

       @return name°
    */
    public String getName() {
	return name;
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	if (as.indexOf('#') != -1) {
	    as.replaceFirst("#", name);
	    wr.println("typedef " + as + ";");
	} else {
	    wr.println("typedef " + as + " " + name + ";");
	}
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	wr.println(""
+ "<tr>\n"
+ "  <td><a href=\"#" + name + "\"><b>" + name + "</b></a><br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	wr.print(""
+ "<p><a name=\"" + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name + "</b></font></p>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n"
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	wr.println("\\Sid{" + Tex.safe(name) + "}");
	wr.println(desc.getTexText());
    }
}
